//+------------------------------------------------------------------+
//|                                                  !Experement.mq4 |
//|                                         Copyright  2011, Korwin |
//|                                             korwin-kor@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Korwin"
#property link      "korwin-kor@yandex.ru"

#property  indicator_chart_window
#property  indicator_buffers 2
#property  indicator_color1  Red
#property  indicator_color2  White

extern int divisor=6;

double buf0[], buf1[], x,y, last,new;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {   
   SetIndexBuffer(0,buf0); SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,2); SetIndexArrow(0,159);
   SetIndexBuffer(1,buf1); SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,2); SetIndexArrow(1,159);
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i, CB=IndicatorCounted();
   if (CB>0) CB--;
   for(i=Bars-CB; i>=0; i--)
      {
       if(buf0[i+1]==EMPTY_VALUE && buf1[i+1]==EMPTY_VALUE)
         {
          if(Close[i+1]>Open[i+1]) buf1[i+1]=Low[i+1];
          if(Close[i+1]<Open[i+1]) buf0[i+1]=High[i+1];
         }
       if(buf0[i+1]!=EMPTY_VALUE)
         {
         if(buf0[i+1]>Close[i+1]) buf0[i]=buf0[i+1]-(High[i+1]-Low[i+1])/divisor;
          else 
            {
             buf0[i]=EMPTY_VALUE; 
             x=i;
             int u=iLowest(NULL,0,MODE_LOW,(y-i),i);
          //   buf1[i+1]=Low[u];
             for(;u>=i;u--)
               {if(last!=EMPTY_VALUE) {new=last+(High[u+1]-Low[u+1])/divisor; last=new;}
                else new=Low[u];
               }
             buf1[i]=new; new=EMPTY_VALUE; last=EMPTY_VALUE;
          //   buf1[i+1]=Low[i+1];
          //   buf1[i]=buf1[i+1]+(High[i+1]-Low[i+1])/divisor;
            }
         }
       if(buf1[i+1]!=EMPTY_VALUE) 
         {
          if(buf1[i+1]<Close[i+1]) buf1[i]=buf1[i+1]+(High[i+1]-Low[i+1])/divisor;
          else
            {
             buf1[i]=EMPTY_VALUE;
             y=i;
             u=iHighest(NULL,0,MODE_HIGH,(x-i),i);
           //  buf0[i+1]=High[u];
             for(;u>=i;u--)
               {if(last!=EMPTY_VALUE) {new=last-(High[u+1]-Low[u+1])/divisor; last=new;}
                else new=High[u];
               }
             buf0[i]=new; new=EMPTY_VALUE; last=EMPTY_VALUE;
           //  buf0[i+1]=High[i+1];
           //  buf0[i]=buf0[i+1]-(High[i+1]-Low[i+1])/divisor;
            }
         }
      }
   return(0);
  }

//+------------------------------------------------------------------+